Subject: Re: [PATCH v3 06/14] RDMA/irdma: Use irq_set_affinity_and_hint

From: Leon Romanovsky <[email-masked]>
Date: Wed, 14 Jul 2021 16:02:56 +0300

On Wed, Jul 14, 2021 at 08:56:41AM -0400, Nitesh Lal wrote:
> On Wed, Jul 14, 2021 at 8:03 AM Leon Romanovsky <[email-masked]> wrote:
> >
> > On Tue, Jul 13, 2021 at 05:14:54PM -0400, Nitesh Narayan Lal wrote:
> > > The driver uses irq_set_affinity_hint() to update the affinity_hint mask
> > > that is consumed by the userspace to distribute the interrupts and to apply
> > > the provided mask as the affinity for its interrupts. However,
> > > irq_set_affinity_hint() applying the provided cpumask as an affinity for
> > > the interrupt is an undocumented side effect.
> > >
> > > To remove this side effect irq_set_affinity_hint() has been marked
> > > as deprecated and new interfaces have been introduced. Hence, replace the
> > > irq_set_affinity_hint() with the new interface irq_set_affinity_and_hint()
> > > where the provided mask needs to be applied as the affinity and
> > > affinity_hint pointer needs to be set and replace with
> > > irq_update_affinity_hint() where only affinity_hint needs to be updated.
> > >
> > > Signed-off-by: Nitesh Narayan Lal <[email-masked]>
> > > ---
> > >  drivers/infiniband/hw/irdma/hw.c | 4 ++--
> > >  1 file changed, 2 insertions(+), 2 deletions(-)
> > >
> > > diff --git a/drivers/infiniband/hw/irdma/hw.c b/drivers/infiniband/hw/irdma/hw.c
> > > index 7afb8a6a0526..7f13a051d4de 100644
> > > --- a/drivers/infiniband/hw/irdma/hw.c
> > > +++ b/drivers/infiniband/hw/irdma/hw.c
> > > @@ -537,7 +537,7 @@ static void irdma_destroy_irq(struct irdma_pci_f *rf,
> > >       struct irdma_sc_dev *dev = &rf->sc_dev;
> > >
> > >       dev->irq_ops->irdma_dis_irq(dev, msix_vec->idx);
> > > -     irq_set_affinity_hint(msix_vec->irq, NULL);
> > > +     irq_update_affinity_hint(msix_vec->irq, NULL);
> > >       free_irq(msix_vec->irq, dev_id);
> > >  }
> > >
> > > @@ -1087,7 +1087,7 @@ irdma_cfg_ceq_vector(struct irdma_pci_f *rf, struct irdma_ceq *iwceq,
> > >       }
> > >       cpumask_clear(&msix_vec->mask);
> > >       cpumask_set_cpu(msix_vec->cpu_affinity, &msix_vec->mask);
> > > -     irq_set_affinity_hint(msix_vec->irq, &msix_vec->mask);
> > > +     irq_set_affinity_and_hint(msix_vec->irq, &msix_vec->mask);
> >
> > I think that it needs to be irq_update_affinity_hint().
> >
> 
> Ah! I got a little confused from our last conversation about mlx5.
> 
> IIUC mlx5 sub-function use case uses irdma (?) and that's why I thought
> that perhaps we would also want to define the affinity here from the beginning.

mlx5 is connected to mlx5_ib/mlx5_vdpa e.t.c.

Not sure about that, but I think that only mlx5 implements SIOV model.

> 
> In any case, I will make the change and re-post.
> 
> --
> Thanks
> Nitesh
>